Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/RenderState.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/RenderState.cpp	(revision 2782)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/RenderState.cpp	(revision 2800)
@@ -9,6 +9,4 @@
 
 
-/** Constructor setting render as default state.
-*/
 RenderState::RenderState():
 mAlphaTestEnabled(false), 
@@ -22,9 +20,10 @@
 bool RenderState::SetState(Mode mode)
 {
+	///////////
 	//-- just change the modewhen necessary
+
 	if (mode == mMode) return false;
 
 	mMode = mode;
-	//++ state_changes;
 
 	if (mode == QUERY)
@@ -62,6 +61,6 @@
 	{
 		mTexturesEnabled = true;
-		glEnable(GL_TEXTURE_2D);
-		glEnableClientState(GL_TEXTURE_COORD_ARRAY);
+		//glEnable(GL_TEXTURE_2D);
+		//glEnableClientState(GL_TEXTURE_COORD_ARRAY);
 	}
 
@@ -74,6 +73,6 @@
 	{
 		mAlphaTestEnabled = true;
-		glEnable(GL_ALPHA_TEST);
-		glAlphaFunc(GL_GEQUAL, 0.5f);
+		//glEnable(GL_ALPHA_TEST);
+		//glAlphaFunc(GL_GEQUAL, 0.5f);
 	}
 }
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/ResourceManager.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/ResourceManager.cpp	(revision 2795)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/ResourceManager.cpp	(revision 2800)
@@ -81,5 +81,5 @@
 	}
 
-	cout << "loaded " << mTextureTable.size() << " textures" << endl;
+	cout << "loaded " << (int)mTextureTable.size() << " textures" << endl;
 }
 
@@ -102,5 +102,5 @@
 	}
 
-	cout << "loaded " << mGeometryTable.size() << " shapes" << endl;
+	cout << "loaded " << (int)mGeometryTable.size() << " shapes" << endl;
 }
 
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/RenderTraverser.h
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/RenderTraverser.h	(revision 2795)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/RenderTraverser.h	(revision 2800)
@@ -7,4 +7,5 @@
 #include "Camera.h"
 #include "RenderQueue.h"
+#include "Timer/PerfTimer.h"
 
 
@@ -37,8 +38,12 @@
 	int mNumIssuedQueries;
 	int mNumStateChanges;
+	int mNumBatches;
 	
 	double mRenderTime;
+
+	double mWaitTime;
+	double mQueryTime;
+	double mRestTime;
 };
-
 
 
@@ -49,5 +54,5 @@
 public:
 	
-	enum {CULL_FRUSTUM, STOP_AND_WAIT, CHC, CHCPLUSPLUS, NUM_RENDERMODES};
+	enum {CULL_FRUSTUM, STOP_AND_WAIT, CHC, CHCPLUSPLUS, NUM_TRAVERSAL_TYPES};
 
 	RenderTraverser();
@@ -118,4 +123,5 @@
 	void SetShowBounds(bool showBounds);
 
+	virtual int GetType() const = 0;
 	
 protected:
@@ -187,4 +193,9 @@
 
 	bool mShowBounds;
+
+	// timers
+	PerfTimer restTimer;
+	PerfTimer waitTimer;
+	PerfTimer queryTimer;
 };
 
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/SceneQuery.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/SceneQuery.cpp	(revision 2797)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/SceneQuery.cpp	(revision 2800)
@@ -5,8 +5,20 @@
 #include "SceneQuery.h"
 #include "RenderTraverser.h"
+#include <IL/il.h>
+#include <assert.h>
 
 
-void startil();
-void stopil();
+void startil()
+{
+	ilInit();
+	assert(ilGetError() == IL_NO_ERROR);
+}
+
+
+void stopil()
+{
+	ilShutDown();
+	assert(ilGetError() == IL_NO_ERROR);
+}
 
 
@@ -17,6 +29,7 @@
 
 
-const static int viewport[4] = {0, 0, 512, 512};
-//const static int viewport[4] = {0, 0, 1024, 768};
+//const static int viewport[4] = {0, 0, 512, 512};
+const static int viewport[4] = {0, 0, 1024, 768};
+//const static int viewport[4] = {0, 0, 2048, 2048};
 
 
@@ -34,13 +47,20 @@
 	int py = (pt.y - mSceneBox.Min(1)) * (viewport[3] - 1) / mSceneBox.Size(1);
 
-	const float d = mDepth[px + py * viewport[1]];
+	unsigned char d = mDepth[px + py * viewport[2]];
 
-	if (d > 0.0f)
+	const float offs = mSceneBox.Size(2) * 1e-1f;
+
+	static float depth = (float)d;
+
+	if (d > 0)
 	{
-		pt.z =  mSceneBox.Max().z - mSceneBox.Size().z * d;
-		cout << "new depth " << pt.z << " (" << d << ")" << endl;
+		const float x = 0.1f;
+		depth = depth * x + d * (1.0f - x);
+		pt.z =  mSceneBox.Max().z - mSceneBox.Size().z * depth / 255.0f + offs;
+		//cout << "new depth " << pt.z << " (" << d << ")" << endl;
 
 		return true;
 	}
+	//cout << "invalid depth: " << d << endl;
 
 	return false;
@@ -65,4 +85,6 @@
 
 	//glPixelStorei(GL_PACK_ROW_LENGTH, viewport[2]);
+	glPixelStorei(GL_PACK_ALIGNMENT, 1);
+	glReadBuffer(GL_BACK);
 
 	// hack: should create offscreen buffer for this
@@ -80,5 +102,6 @@
 	glClear(GL_DEPTH_BUFFER_BIT);
 
-	mDepth = new float[viewport[2] * viewport[3]];
+	mDepth = new unsigned char[viewport[2] * viewport[3]];
+	//mDepth = new float[viewport[2] * viewport[3]];
 
 	//renderer->SetCamera(orthoCam);
@@ -86,6 +109,26 @@
 	renderer->RenderScene();
 
-	glReadPixels(0, 0, viewport[2], viewport[3], GL_DEPTH_COMPONENT, GL_FLOAT, mDepth);
+	glReadPixels(0, 0, viewport[2], viewport[3], GL_DEPTH_COMPONENT, GL_UNSIGNED_BYTE, mDepth);
+	//glReadPixels(0, 0, viewport[2], viewport[3], GL_DEPTH_COMPONENT, GL_FLOAT, mDepth);
+/*
+	startil();
 
+	if (!ilTexImage(viewport[2], viewport[3], 1, 1, IL_LUMINANCE, IL_UNSIGNED_BYTE, mDepth))
+	{
+		cerr << "IL error " << ilGetError() << endl;
+		stopil();
+		return;
+	}
+
+	ILstring writename = ILstring("out.tga");
+
+	ilSetInteger(IL_TGA_RLE, 1);
+	if (!ilSaveImage(writename))
+	{
+		cerr << "TGA write error " << ilGetError() << endl;
+	}
+
+	stopil();
+*/
 	DEL_PTR(orthoCam);
 }
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/RenderQueue.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/RenderQueue.cpp	(revision 2795)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/RenderQueue.cpp	(revision 2800)
@@ -21,5 +21,5 @@
 	int tsize2 = t2 ? t2->GetByteSize() : 0;
 
-	return tsize1 < tsize2;
+	return tsize1 > tsize2;
 }
 
@@ -88,4 +88,5 @@
 	Debug << "\nrq size: " << GetSize() << endl;
 	Debug << "texture size: " << endl;
+
 	// show ordering by texture size
 	for (sit = mEntities.begin(); sit != sit_end; ++ sit)
@@ -93,4 +94,5 @@
 		SceneEntity *ent = *sit;
 		Texture *t = ent->GetMaterial()->GetTexture();
+	
 		int tsize = t ? t->GetByteSize() : 0;
 		Debug << tsize << " ";
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/Bvh.h
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/Bvh.h	(revision 2792)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/Bvh.h	(revision 2800)
@@ -52,4 +52,6 @@
 		/// if the node is newly processed with no prior history available
 		bool mIsNew;
+		/// the frame this node was last queried
+		int mLastQueriedFrame;
 	};
 
@@ -113,6 +115,6 @@
 	inline void SetTurnedVisibleFrame(int turnedVisibleFrame);
 
-	inline int GetLastTestedFrame();
-	inline void SetLastTestedFrame(int lastTested);
+	inline int GetLastQueriedFrame() const;
+	inline void SetLastQueriedFrame(int lastTested);
 	
 	inline bool IsViewFrustumCulled() const;
@@ -155,6 +157,4 @@
 	/////////////
 	
-	/// some flags
-	//int mFlags;
 	/// the depth of this node
 	unsigned char mDepth;
@@ -217,7 +217,9 @@
 
 
+
 /////////////////
 //-- public inline functions
 
+
 int BvhNode::GetLastVisitedFrame() const 
 { 
@@ -268,5 +270,5 @@
 
 
-void BvhNode::SetViewFrustumCulled(const bool frustumCulled) 
+void BvhNode::SetViewFrustumCulled(bool frustumCulled) 
 { 
 	mVisibility.mIsFrustumCulled = frustumCulled; 
@@ -280,5 +282,5 @@
 
 
-void BvhNode::SetIsNew(const bool isNew) 
+void BvhNode::SetIsNew(bool isNew) 
 { 
 	mVisibility.mIsNew = isNew; 
@@ -320,4 +322,17 @@
 	return mVisibility.mAssumedVisibleFrameId;
 }
+
+
+int BvhNode::GetLastQueriedFrame() const
+{
+	return mVisibility.mLastQueriedFrame;
+}
+
+
+void BvhNode::SetLastQueriedFrame(int lastTested)
+{
+	mVisibility.mLastQueriedFrame = lastTested;
+}
+
 
 
@@ -429,4 +444,11 @@
 	*/
 	inline int GetNumLeaves() const { return mNumNodes / 2 + 1;}
+	/** Returns number of 'virtual' nodes in the hierarchy, i.e.
+		the number of nodes actually used for traversal.
+	*/
+	int GetNumVirtualNodes() const  { return mNumVirtualNodes; }
+	/** Returns number of bvh leaves.
+	*/
+	inline int GetNumVirtualLeaves() const { return mNumVirtualNodes / 2 + 1;}
 	/** Returns root node of the bvh.
 	*/
@@ -512,5 +534,5 @@
 	*/
 	void SetVirtualLeaves(int numTriangles);
-
+	
 
 	////////
@@ -526,11 +548,10 @@
 	void SetAreaRatioThresholdForTestingChildren(float ratio);
 
+
+	////////////////////////////
+
 	/** Returns stats.
 	*/
 	const BvhStats &GetBvhStats() const { return mBvhStats; }
-	/** Returns number of 'virtual' nodes in the hierarchy, i.e.
-		the number of nodes actually used for traversal.
-	*/
-	int GetNumVirtualNodes() const  { return mNumVirtualNodes; }
 	/** Render wireframe bvh for visualization purpose.
 	*/
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/gzstream.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/gzstream.cpp	(revision 2800)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/gzstream.cpp	(revision 2800)
@@ -0,0 +1,175 @@
+// ============================================================================
+// gzstream, C++ iostream classes wrapping the zlib compression library.
+// Copyright (C) 2001  Deepak Bandyopadhyay, Lutz Kettner
+//
+// This library is free software; you can redistribute it and/or
+// modify it under the terms of the GNU Lesser General Public
+// License as published by the Free Software Foundation; either
+// version 2.1 of the License, or (at your option) any later version.
+//
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+// Lesser General Public License for more details.
+//
+// You should have received a copy of the GNU Lesser General Public
+// License along with this library; if not, write to the Free Software
+// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+// ============================================================================
+//
+// File          : gzstream.C
+// Revision      : $Revision: 1.1 $
+// Revision_date : $Date: 2004/02/16 14:46:00 $
+// Author(s)     : Deepak Bandyopadhyay, Lutz Kettner
+// 
+// Standard streambuf implementation following Nicolai Josuttis, "The 
+// Standard C++ Library".
+// ============================================================================
+
+#include "gzstream.h"
+#include <string.h>  // for memcpy
+
+#ifdef GZSTREAM_NAMESPACE
+namespace GZSTREAM_NAMESPACE {
+#endif
+
+// ----------------------------------------------------------------------------
+// Internal classes to implement gzstream. See header file for user classes.
+// ----------------------------------------------------------------------------
+
+// --------------------------------------
+// class gzstreambuf:
+// --------------------------------------
+
+gzstreambuf*
+gzstreambuf::open( const char* name, int open_mode) {
+  if ( is_open() )
+    return (gzstreambuf*)0;
+  mode = open_mode;
+  // no append nor read/write mode
+  if ((mode & std::ios::ate) || (mode & std::ios::app)
+      || ((mode & std::ios::in) && (mode & std::ios::out)))
+    return (gzstreambuf*)0;
+  char fmode[10];
+  char* fmodeptr = fmode;
+  if ( mode & std::ios::in)
+    *fmodeptr++ = 'r';
+  else
+    if ( mode & std::ios::out)
+      *fmodeptr++ = 'w';
+  *fmodeptr++ = 'b';
+  *fmodeptr = '\0';
+  file = gzopen( name, fmode);
+  if (file == 0)
+    return (gzstreambuf*)0;
+  opened = 1;
+  return this;
+}
+  
+gzstreambuf *
+gzstreambuf::close() {
+  if ( is_open()) {
+    sync();
+    opened = 0;
+    if ( gzclose( file) == Z_OK)
+      return this;
+  }
+  return (gzstreambuf*)0;
+}
+  
+int
+gzstreambuf::underflow() { // used for input buffer only
+  if ( gptr() && ( gptr() < egptr()))
+    return * reinterpret_cast<unsigned char *>( gptr());
+  
+  if ( ! (mode & std::ios::in) || ! opened)
+    return EOF;
+  // Josuttis' implementation of inbuf
+  int n_putback = gptr() - eback();
+  if ( n_putback > 4)
+    n_putback = 4;
+  memcpy( buffer + (4 - n_putback), gptr() - n_putback, n_putback);
+  
+  int num = gzread( file, buffer+4, gzbufferSize-4);
+  if (num <= 0) // ERROR or EOF
+    return EOF;
+  
+  // reset buffer pointers
+  setg( buffer + (4 - n_putback),   // beginning of putback area
+	buffer + 4,                 // read position
+	buffer + 4 + num);          // end of buffer
+  
+  // return next character
+  return * reinterpret_cast<unsigned char *>( gptr());    
+}
+  
+int
+gzstreambuf::flush_buffer() {
+  // Separate the writing of the buffer from overflow() and
+  // sync() operation.
+  int w = pptr() - pbase();
+  if ( gzwrite( file, pbase(), w) != w)
+    return EOF;
+  pbump( -w);
+  return w;
+}
+  
+int
+gzstreambuf::overflow( int c) { // used for output buffer only
+  if ( ! ( mode & std::ios::out) || ! opened)
+    return EOF;
+  if (c != EOF) {
+    *pptr() = c;
+    pbump(1);
+  }
+  if ( flush_buffer() == EOF)
+    return EOF;
+  return c;
+}
+  
+int
+gzstreambuf::sync() {
+  // Changed to use flush_buffer() instead of overflow( EOF)
+  // which caused improper behavior with std::endl and flush(),
+  // bug reported by Vincent Ricard.
+  if ( pptr() && pptr() > pbase()) {
+    if ( flush_buffer() == EOF)
+      return -1;
+  }
+  return 0;
+}
+  
+  
+  // --------------------------------------
+  // class gzstreambase:
+// --------------------------------------
+
+gzstreambase::gzstreambase( const char* name, int mode)
+{
+  init( &buf);
+  open( name, mode);
+}
+  
+  gzstreambase::~gzstreambase()
+  {
+    buf.close();
+  }
+  
+  void
+  gzstreambase::open( const char* name, int open_mode) {
+    if ( ! buf.open( name, open_mode))
+      clear( rdstate() | std::ios::badbit);
+}
+
+void gzstreambase::close() {
+    if ( buf.is_open())
+        if ( ! buf.close())
+            clear( rdstate() | std::ios::badbit);
+}
+
+#ifdef GZSTREAM_NAMESPACE
+} // namespace GZSTREAM_NAMESPACE
+#endif
+
+// ============================================================================
+// EOF //
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/common.h
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/common.h	(revision 2795)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/common.h	(revision 2800)
@@ -476,4 +476,5 @@
 static std::string model_path("data/city/model/");
 
+
 ///////////
 //-- typedefs
@@ -490,13 +491,16 @@
 static std::ofstream Debug("debug.log");
 
-}
-
-#endif
-
-
-
-
-
-
-
-
+
+#define INITIAL_TRIANGLES_PER_VIRTUAL_LEAVES 1000
+
+}
+
+#endif
+
+
+
+
+
+
+
+
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/FriendlyCulling03.sln
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/FriendlyCulling03.sln	(revision 2800)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/FriendlyCulling03.sln	(revision 2800)
@@ -0,0 +1,21 @@
+Microsoft Visual Studio Solution File, Format Version 8.00
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "FriendlyCulling", "FriendlyCulling03.vcproj", "{D1E30B8F-194B-4487-8303-D2CF90ED0048}"
+	ProjectSection(ProjectDependencies) = postProject
+	EndProjectSection
+EndProject
+Global
+	GlobalSection(SolutionConfiguration) = preSolution
+		Debug = Debug
+		Release = Release
+	EndGlobalSection
+	GlobalSection(ProjectConfiguration) = postSolution
+		{D1E30B8F-194B-4487-8303-D2CF90ED0048}.Debug.ActiveCfg = Debug|Win32
+		{D1E30B8F-194B-4487-8303-D2CF90ED0048}.Debug.Build.0 = Debug|Win32
+		{D1E30B8F-194B-4487-8303-D2CF90ED0048}.Release.ActiveCfg = Release|Win32
+		{D1E30B8F-194B-4487-8303-D2CF90ED0048}.Release.Build.0 = Release|Win32
+	EndGlobalSection
+	GlobalSection(ExtensibilityGlobals) = postSolution
+	EndGlobalSection
+	GlobalSection(ExtensibilityAddIns) = postSolution
+	EndGlobalSection
+EndGlobal
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/FriendlyCulling.vcproj
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/FriendlyCulling.vcproj	(revision 2800)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/FriendlyCulling.vcproj	(revision 2800)
@@ -0,0 +1,686 @@
+<?xml version="1.0" encoding="Windows-1252"?>
+<VisualStudioProject
+	ProjectType="Visual C++"
+	Version="8,00"
+	Name="chc_revisited"
+	ProjectGUID="{03661866-4093-4B02-B26A-028EA91AF023}"
+	RootNamespace="chc_revisited"
+	Keyword="Win32Proj"
+	>
+	<Platforms>
+		<Platform
+			Name="Win32"
+		/>
+	</Platforms>
+	<ToolFiles>
+	</ToolFiles>
+	<Configurations>
+		<Configuration
+			Name="Debug|Win32"
+			OutputDirectory="$(SolutionDir)/bin/$(ConfigurationName)"
+			IntermediateDirectory="obj/$(ConfigurationName)"
+			ConfigurationType="1"
+			CharacterSet="1"
+			>
+			<Tool
+				Name="VCPreBuildEventTool"
+			/>
+			<Tool
+				Name="VCCustomBuildTool"
+			/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"
+			/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"
+			/>
+			<Tool
+				Name="VCMIDLTool"
+			/>
+			<Tool
+				Name="VCCLCompilerTool"
+				Optimization="0"
+				AdditionalIncludeDirectories="libs;libs/GL;libs/Devil/include;src;libs/Zlib/include"
+				PreprocessorDefinitions="WIN32;_DEBUG;_CONSOLE;_CRT_SECURE_NO_WARNINGS"
+				MinimalRebuild="true"
+				BasicRuntimeChecks="3"
+				RuntimeLibrary="3"
+				RuntimeTypeInfo="false"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="true"
+				DebugInformationFormat="4"
+			/>
+			<Tool
+				Name="VCManagedResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCPreLinkEventTool"
+			/>
+			<Tool
+				Name="VCLinkerTool"
+				AdditionalDependencies="glut32.lib glew32s.lib glew32.lib DevIL.lib ILUT.lib zlib.lib"
+				LinkIncremental="2"
+				AdditionalLibraryDirectories="libs/GL;libs/Devil/lib;libs/Zlib/lib"
+				GenerateDebugInformation="true"
+				SubSystem="1"
+				TargetMachine="1"
+			/>
+			<Tool
+				Name="VCALinkTool"
+			/>
+			<Tool
+				Name="VCManifestTool"
+			/>
+			<Tool
+				Name="VCXDCMakeTool"
+			/>
+			<Tool
+				Name="VCBscMakeTool"
+			/>
+			<Tool
+				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCAppVerifierTool"
+			/>
+			<Tool
+				Name="VCWebDeploymentTool"
+			/>
+			<Tool
+				Name="VCPostBuildEventTool"
+			/>
+		</Configuration>
+		<Configuration
+			Name="Release|Win32"
+			OutputDirectory="$(SolutionDir)/bin/$(ConfigurationName)"
+			IntermediateDirectory="obj/$(ConfigurationName)"
+			ConfigurationType="1"
+			CharacterSet="1"
+			WholeProgramOptimization="1"
+			>
+			<Tool
+				Name="VCPreBuildEventTool"
+			/>
+			<Tool
+				Name="VCCustomBuildTool"
+			/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"
+			/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"
+			/>
+			<Tool
+				Name="VCMIDLTool"
+			/>
+			<Tool
+				Name="VCCLCompilerTool"
+				Optimization="3"
+				InlineFunctionExpansion="2"
+				EnableIntrinsicFunctions="true"
+				FavorSizeOrSpeed="1"
+				OmitFramePointers="true"
+				EnableFiberSafeOptimizations="true"
+				AdditionalIncludeDirectories="libs;libs/GL;libs/Devil/include;src;libs/Zlib/include"
+				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE; _CRT_SECURE_NO_WARNINGS"
+				StringPooling="true"
+				RuntimeLibrary="2"
+				BufferSecurityCheck="false"
+				EnableEnhancedInstructionSet="2"
+				RuntimeTypeInfo="false"
+				UsePrecompiledHeader="0"
+				BrowseInformation="1"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="true"
+				DebugInformationFormat="3"
+			/>
+			<Tool
+				Name="VCManagedResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCPreLinkEventTool"
+			/>
+			<Tool
+				Name="VCLinkerTool"
+				AdditionalDependencies="glut32.lib glew32s.lib glew32.lib DevIL.lib ILUT.lib zlib.lib"
+				LinkIncremental="1"
+				AdditionalLibraryDirectories="libs/GL;libs/Devil/lib;libs/Zlib/lib"
+				GenerateDebugInformation="false"
+				SubSystem="1"
+				OptimizeReferences="2"
+				EnableCOMDATFolding="2"
+				OptimizeForWindows98="1"
+				TargetMachine="1"
+			/>
+			<Tool
+				Name="VCALinkTool"
+			/>
+			<Tool
+				Name="VCManifestTool"
+			/>
+			<Tool
+				Name="VCXDCMakeTool"
+			/>
+			<Tool
+				Name="VCBscMakeTool"
+			/>
+			<Tool
+				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCAppVerifierTool"
+			/>
+			<Tool
+				Name="VCWebDeploymentTool"
+			/>
+			<Tool
+				Name="VCPostBuildEventTool"
+			/>
+		</Configuration>
+	</Configurations>
+	<References>
+	</References>
+	<Files>
+		<Filter
+			Name="util"
+			>
+			<File
+				RelativePath=".\src\AxisAlignedBox3.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\src\BvhLoader.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\src\BvhLoader.h"
+				>
+			</File>
+			<File
+				RelativePath=".\src\common.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\src\common.h"
+				>
+			</File>
+			<File
+				RelativePath=".\src\glInterface.h"
+				>
+			</File>
+			<File
+				RelativePath=".\src\gzstream.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\src\gzstream.h"
+				>
+			</File>
+			<File
+				RelativePath=".\src\Matrix4x4.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\src\Matrix4x4.h"
+				>
+			</File>
+			<File
+				RelativePath=".\src\Plane3.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\src\Plane3.h"
+				>
+			</File>
+			<File
+				RelativePath=".\src\ResourceManager.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\src\ResourceManager.h"
+				>
+			</File>
+			<File
+				RelativePath=".\src\SceneQuery.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\src\SceneQuery.h"
+				>
+			</File>
+			<File
+				RelativePath=".\src\Triangle3.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\src\Triangle3.h"
+				>
+			</File>
+			<File
+				RelativePath=".\src\Vector3.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\src\Vector3.h"
+				>
+			</File>
+			<Filter
+				Name="timer"
+				>
+				<File
+					RelativePath=".\src\Timer\BenchTimer.cpp"
+					>
+				</File>
+				<File
+					RelativePath=".\src\Timer\BenchTimer.h"
+					>
+				</File>
+				<File
+					RelativePath=".\src\Timer\merror.cpp"
+					>
+				</File>
+				<File
+					RelativePath=".\src\Timer\merror.h"
+					>
+				</File>
+				<File
+					RelativePath=".\src\Timer\mstring.h"
+					>
+				</File>
+				<File
+					RelativePath=".\src\Timer\PerfTimer.h"
+					>
+				</File>
+				<File
+					RelativePath=".\src\Timer\PerfTimerSkeleton.h"
+					>
+				</File>
+				<File
+					RelativePath=".\src\Timer\RDTSCTimer.cpp"
+					>
+				</File>
+				<File
+					RelativePath=".\src\Timer\RDTSCTimer.h"
+					>
+				</File>
+			</Filter>
+		</Filter>
+		<Filter
+			Name="traversal"
+			>
+			<Filter
+				Name="Header Files"
+				>
+				<File
+					RelativePath=".\src\CHCPlusPlusTraverser.h"
+					>
+				</File>
+				<File
+					RelativePath=".\src\CHCTraverser.cpp"
+					>
+					<FileConfiguration
+						Name="Debug|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+					<FileConfiguration
+						Name="Release|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+				</File>
+				<File
+					RelativePath=".\src\CHCTraverser.h"
+					>
+				</File>
+				<File
+					RelativePath=".\src\FrustumCullingTraverser.h"
+					>
+				</File>
+				<File
+					RelativePath=".\src\RenderTraverser.h"
+					>
+				</File>
+				<File
+					RelativePath=".\src\StopAndWaitTraverser.h"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="Source Files"
+				>
+				<File
+					RelativePath=".\src\CHCPlusPlusTraverser.cpp"
+					>
+					<FileConfiguration
+						Name="Debug|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+					<FileConfiguration
+						Name="Release|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+				</File>
+				<File
+					RelativePath=".\src\FrustumCullingTraverser.cpp"
+					>
+					<FileConfiguration
+						Name="Debug|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+					<FileConfiguration
+						Name="Release|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+				</File>
+				<File
+					RelativePath=".\src\RenderTraverser.cpp"
+					>
+					<FileConfiguration
+						Name="Debug|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+					<FileConfiguration
+						Name="Release|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+				</File>
+				<File
+					RelativePath=".\src\StopAndWaitTraverser.cpp"
+					>
+					<FileConfiguration
+						Name="Debug|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+					<FileConfiguration
+						Name="Release|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+				</File>
+			</Filter>
+		</Filter>
+		<Filter
+			Name="render"
+			>
+			<Filter
+				Name="Header Files"
+				Filter="h;hpp;hxx;hm;inl;inc;xsd"
+				UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}"
+				>
+				<File
+					RelativePath=".\src\Bvh.h"
+					>
+				</File>
+				<File
+					RelativePath=".\src\Camera.h"
+					>
+				</File>
+				<File
+					RelativePath=".\src\Geometry.h"
+					>
+				</File>
+				<File
+					RelativePath=".\src\OcclusionQuery.h"
+					>
+				</File>
+				<File
+					RelativePath=".\src\RenderQueue.h"
+					>
+				</File>
+				<File
+					RelativePath=".\src\RenderState.h"
+					>
+				</File>
+				<File
+					RelativePath=".\src\SceneEntity.h"
+					>
+				</File>
+				<File
+					RelativePath=".\src\Texture.h"
+					>
+				</File>
+				<File
+					RelativePath=".\src\Visualization.h"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="Source Files"
+				Filter="cpp;c;cc;cxx;def;odl;idl;hpj;bat;asm;asmx"
+				UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}"
+				>
+				<File
+					RelativePath=".\src\Bvh.cpp"
+					>
+					<FileConfiguration
+						Name="Debug|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+					<FileConfiguration
+						Name="Release|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+				</File>
+				<File
+					RelativePath=".\src\Camera.cpp"
+					>
+					<FileConfiguration
+						Name="Debug|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+					<FileConfiguration
+						Name="Release|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+				</File>
+				<File
+					RelativePath=".\src\chcdemo.cpp"
+					>
+				</File>
+				<File
+					RelativePath=".\src\Geometry.cpp"
+					>
+				</File>
+				<File
+					RelativePath=".\src\Material.cpp"
+					>
+				</File>
+				<File
+					RelativePath=".\src\OcclusionQuery.cpp"
+					>
+					<FileConfiguration
+						Name="Debug|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+					<FileConfiguration
+						Name="Release|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+				</File>
+				<File
+					RelativePath=".\src\RenderQueue.cpp"
+					>
+					<FileConfiguration
+						Name="Debug|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+					<FileConfiguration
+						Name="Release|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+				</File>
+				<File
+					RelativePath=".\src\RenderState.cpp"
+					>
+					<FileConfiguration
+						Name="Debug|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+					<FileConfiguration
+						Name="Release|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+				</File>
+				<File
+					RelativePath=".\src\SceneEntity.cpp"
+					>
+				</File>
+				<File
+					RelativePath=".\src\Texture.cpp"
+					>
+					<FileConfiguration
+						Name="Debug|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+					<FileConfiguration
+						Name="Release|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+				</File>
+				<File
+					RelativePath=".\src\Visualization.cpp"
+					>
+					<FileConfiguration
+						Name="Debug|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+					<FileConfiguration
+						Name="Release|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							ObjectFile="$(IntDir)\$(InputName)1.obj"
+							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
+						/>
+					</FileConfiguration>
+				</File>
+			</Filter>
+		</Filter>
+		<File
+			RelativePath=".\ReadMe.txt"
+			>
+		</File>
+	</Files>
+	<Globals>
+	</Globals>
+</VisualStudioProject>
